package
{
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Mask;
	import net.flashpunk.masks.Hitbox;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	/**
	 * ...
	 * @author David Williams
	 */
	public class Player extends Entity
	{
		public var pgfx:Image;
		public var veloc:Point;
		
		public var gun:WpnBase;
		
		public function Player(_location:Point)
		{
			this.x = _location.x;
			this.y = _location.y;
			this.type = "player";
			
			this.veloc = new Point(0, 0);
			
			graphic = pgfx = new Image(new BitmapData(25, 25, false, 0xFFFFFF));
			pgfx.tinting = 1;
			pgfx.color = 0xFFFF44;
			mask = new Hitbox(pgfx.width, pgfx.height);
		}
		
		override public function added():void
		{
			
		}
		
		override public function update():void
		{
			//movement
			if (!collide("platform", x, y + 1))
			{
				if (veloc.y < 6)
				{
					veloc.y += 1;
				}
			}
			else
			{
				if (Input.check(Key.W))
				{
					veloc.y = -12;
				}
				else
				{
					veloc.y = 0;
				}
			}
			if (Input.check(Key.A))
			{
				veloc.x -= 1;
			}
			if (Input.check(Key.D))
			{
				veloc.x += 1;
			}
			if (!Input.check(Key.D) && !Input.check(Key.A))
			{
				if (veloc.x < 0)
				{
					veloc.x += 0.2;
				}
				else if (veloc.x > 0)
				{
					veloc.x -= 0.2;
				}
			}
			switch (true)
			{
				case veloc.x < -3: 
					veloc.x = -3;
					break;
				case veloc.x > 3: 
					veloc.x = 3;
					break;
				default: 
					break;
			}
			moveBy(veloc.x, veloc.y, "platform");
			veloc.x = int(veloc.x);
			veloc.y = int(veloc.y);
			FP.clampInRect(this, 0, 0, 1280 - pgfx.width, FP.bounds.height, 2);
			if (gun)
			{
				gun.x = this.x + 12;
				gun.y = this.y + 12;
				//gunz
				if (Input.mousePressed)
				{
					gun.fire();
				}
			}
		}
		override public function moveCollideY(e:Entity):Boolean
		{
			veloc.y = 0;
			return super.moveCollideY(e);
		}
	}

}