package  
{
	import flash.display.Bitmap;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Tilemap;
	import flash.display.BitmapData;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	
	/**
	 * ...
	 * @author David Williams
	 */
	public class TileLevel extends Entity 
	{
		private var tilesheet:Tilemap;
		private var grid:Pixelmask;
		private var zero:Point = new Point(0, 0);
		[Embed(source = "../lib/tiles.png")]private const TILES:Class;
		public function TileLevel() 
		{
			layer = 10;
			type = "platform";
			
			graphic = tilesheet = new Tilemap(TILES, 1280, 480, 20, 20);
		
			tilesheet.setRectOutline(0, 0, 32, 24, 0);
			for (var i:int = 0; i < 64; i++)
			{
				tilesheet.setTile(i, 23, 1);
				tilesheet.setTile(i, 0, 1);
			}
			for (var j:int = 1; j < 23; j++)
			{
				tilesheet.setTile(0, j, 1);
				tilesheet.setTile(63, j, 1);
			}
			for (var k:int = 0; k < 4; k++)
			{
				tilesheet.setTile(20 + k, 23 - k, 1);
				tilesheet.setTile(20 + 4 + k, 23 - 4 + k, 1);
			}
			adjustMask();
			mask = grid;
		}
		private function adjustMask():void
		{
			var temp:BitmapData = new BitmapData(tilesheet.width, tilesheet.height, true, 0);
			tilesheet.render(temp, zero, zero);
			grid = new Pixelmask(temp);
		}
	}

}