package
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import flash.geom.Point;
	import net.flashpunk.masks.Hitbox;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	/**
	 * ...
	 * @author David Williams
	 */
	public class WpnBase extends Entity
	{
		public var bullet:Projectile;
		public var held:Boolean = false;
		public var stat:Boolean = false;
		public var veloc:Point;
		
		private var prevHeld:Boolean = false;
		private var gfx:Image;
		private var ma:Number;
		
		public function WpnBase(_gfx:Image, _bullet:Projectile)
		{
			graphic = gfx = _gfx;
			gfx.originY = gfx.height / 2;
			mask = new Hitbox(gfx.width, gfx.height, 0, -gfx.originY);
			bullet = _bullet;
			type = "weapon";
			veloc = new Point(0, 0);
		}
		
		public function fire():void
		{
			var angAdj:Number = ma * Math.PI / 180;
			var xAdj:Number = Math.round(this.width * Math.cos(angAdj) - (this.height / 2) * Math.sin(angAdj));
			var yAdj:Number = Math.round(this.width * Math.sin(angAdj) + (this.height / 2) * Math.cos(angAdj));
			bullet.x = this.x + xAdj;
			bullet.y = this.y + yAdj;
			
			var proj:Projectile = (world.add(copy(bullet)) as Projectile);
			proj.shoot(ma);
		}
		
		override public function update():void
		{
			if (held)
			{
				ma = -FP.angle(this.x, this.y, world.mouseX, world.mouseY);
				gfx.angle = -ma-3;
				
			}
			else
			{
				var plyr:Player = collide("player", x, y) as Player;
				if (plyr && prevHeld == held)
				{
					if (Input.pressed(Key.E))
					{
						if (plyr.gun)
						{
							plyr.gun.drop();
						}
						this.held = true;
						this.stat = true;
						plyr.gun = this;
					}
					else
					{
						//return;
					}
				}
				if (!collide("platform", x, y + 1) && !stat)
				{
					if (veloc.y < 3)
					{
						veloc.y += 1;
					}
				}
				else if (collide("platform", x+2, y))
				{
					x -= 3;
				}
				else if (collide("platform", x-2, y))
				{
					x += 3;
				}
				else
				{
					veloc.y = 0;
					veloc.x = 0;
					stat = true;
				}
				moveBy(veloc.x, veloc.y, "platform");
				veloc.x = int(veloc.x);
				veloc.y = int(veloc.y);
			}
			prevHeld = held;
		}
		public function drop():void
		{
			held = false;
			stat = false;
			gfx.angle = 0;
			veloc.y -= 4;
			x -= width / 2;
		}
		public function copy(_bul:Projectile):Projectile
		{
			var p:Projectile = new Projectile(_bul.damage, _bul.speed);
			p.graphic = _bul.graphic;
			p.x = _bul.x;
			p.y = _bul.y;
			p.mask = new Hitbox(_bul.width, _bul.height);
			
			return p;
		}
	}

}